unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OpenGL, ToolsOGL;

type
  TfrmMain = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
  end;
const
  AngleDl=5; //     
var
  frmMain: TfrmMain;
  DC : HDC;
  hrc: HGLRC;
  AngleX, AngleY, AngleZ: integer;
  mode: GLenum;
implementation

{$R *.DFM}

procedure TfrmMain.FormPaint(Sender: TObject);
var
  i, n: integer;
  x, y, r, a: double;
begin
  glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);      //   
  glLoadIdentity;

  //      
  glRotatef(AngleX, 1.0, 0.0, 0.0);
  glRotatef(AngleY, 0.0, 1.0, 0.0);
  glRotatef(AngleZ, 0.0, 0.0, 1.0);

  //  
  glBegin (GL_LINES);
    //  x
    glColor3f(1, 1, 1); glVertex2f (-6, 0);
    glColor3f(0, 0, 1); glVertex2f (6, 0);
    //  y
    glColor3f(1, 1, 1); glVertex2f (0, -6);
    glColor3f(0, 1, 0); glVertex2f (0, 6);
    //  z
    glColor3f(1, 1, 1); glVertex3f (0, 0, -6);
    glColor3f(1, 0, 0); glVertex3f (0, 0, 6);
  glEnd;

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glPolygonMode(GL_FRONT_AND_BACK, mode);
  glBegin (GL_QUAD_STRIP);
  r := 0.5;
  n := 20;
  for i := 0 to n do
  begin
    a := 2*pi/n * i;
    x := r * Cos(a);
    y := r * Sin(a);
    glNormal3f(x, y, 0);
    glVertex3d(x, y, -0.5);
    glVertex3d(x, y, 0.5);
  end;
  glEnd;
  glDisable(GL_LIGHTING);

  glFlush;
  glFinish;

  SwapBuffers(DC);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin
 DC := GetDC (Handle);

 // 
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (dc, @pfd);
 SetPixelFormat (dc, nPixelFormat, @pfd);

 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);

 //   :
 AngleX:=0;
 AngleY:=30;
 AngleZ:=0;

 glClearColor (1, 1, 1, 1.0); //  
 glEnable(GL_DEPTH_TEST);

 mode := GL_FILL;

end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC (Handle, DC);
 DeleteDC(DC);
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key = VK_ESCAPE then Close;
 case Key of
  VK_INSERT: inc(AngleX, AngleDl);
  VK_DELETE: dec(AngleX, AngleDl);

  VK_HOME:   inc(AngleY, AngleDl);
  VK_END:    dec(AngleY, AngleDl);

  VK_PRIOR:  inc(AngleZ, AngleDl);
  VK_NEXT:   dec(AngleZ, AngleDl);

  VK_F1: mode := GL_FILL;
  VK_F2: mode := GL_LINE;
  VK_F3: mode := GL_POINT;
 end;
 InvalidateRect(Handle, nil, False);
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
 glViewport(0, 0, ClientWidth, ClientHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 glOrtho(-1, 1, -1, 1, -1, 1);
 glMatrixMode(GL_MODELVIEW);
 InvalidateRect(Handle, nil, False);
end;

end.

